Name:		hp-ixgbe
Version:	5.3.5.1
Release:	5.%{distro}
Group:		System/Kernel
Vendor:		Intel Corporation
URL:		http://www.intel.com/network/connectivity/products/server_adapters.htm
Packager:	Hewlett-Packard Enterprise Company
License:	GPL
Source0:	%{name}-%{version}.tar.gz
Source1:        %{name}.files
BuildRoot:	%{_tmppath}/%{name}-%{version}-build
Summary:	Intel(R) 10GbE PCI Express Ethernet Kernel Module for HP ProLiant systems

%define debug_package %{nil}

%if "%{_vendor}" == "suse"
%if %{!?KVER:1}%{?KVER:0}
%ifarch x86_64
%define flav default kdump smp xen
%else
%define flav default bigsmp kdump kdumpae smp xen xenpae pae
%endif
%endif

%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"-" '{print $3}')
%endif
%endif

%if "%{_vendor}" == "redhat"
%if %{!?KVER:1}%{?KVER:0}
%define flav ""
%endif
%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"el5" '{print $2}')
%if "%{flav}" == ""
%define flav default
%endif
%endif
%endif

%if "%{_vendor}" == "suse"
%if 0%{?suse_version} >= 1315
BuildRequires: kernel-syms
%else
BuildRequires: kernel-source kernel-syms
%endif
%define install_mod_dir updates/%{name}
%define kernel_source /usr/src/linux-obj/%{_target_cpu}
%{suse_kernel_module_package -x %flav}
%else
BuildRequires: %kernel_module_package_buildreqs
%define install_mod_dir extra/%{name}
%{kernel_module_package -f %{SOURCE1} %flav}
%endif

%description
Intel(R) 10GbE PCI Express Ethernet Kernel Module for HP ProLiant systems
SRPMS available at http://downloads.linux.hpe.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hpe.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package KMP
Summary: Intel(R) 10GbE PCI Express Ethernet Kernel Module for HP ProLiant systems
Group: System/Kernel

%description KMP
Intel(R) 10GbE PCI Express Ethernet Kernel Module for HP ProLiant systems
SRPMS available at http://downloads.linux.hpe.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hpe.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package doc
Summary: Documentation for the %{name} kernel module
Group: System/Kernel
%if "%{_vendor}" == "redhat"
Requires: %{name}-kmod = %{version}-%{release}
%else
Requires: %{name}-kmp
%endif

%description doc
Documentation for the Intel(R) 10GbE PCI Express Ethernet Kernel Module for HP ProLiant systems

%prep
%setup
set -- *
mkdir source
mv "$@" source/
mkdir obj
echo "override ixgbe * weak-updates/%{name}" > %{name}.conf

%build
export EXTRA_CFLAGS='-DVERSION="%version"'

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
	rm -rf obj/$flavor
	cp -r source obj/$flavor
	make -C $PWD/obj/$flavor/src KSRC=%{kernel_source $flavor}

	#mark modules executable so that strip-to-file can strip them
	find obj/$flavor/ -name "*.ko" -type f -exec chmod u+x '{}' +
done
gzip < source/ixgbe.7 > source/ixgbe.7.gz

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
	make -C $PWD/obj/$flavor/src KSRC=%{kernel_source $flavor} install

	#Cleanup unnecessary kernel-generated module dependency files.
	find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;
done
install -D -m 644 source/ixgbe.7.gz $RPM_BUILD_ROOT/%{_mandir}/man7/ixgbe.7.gz
install -d %{buildroot}%{_sysconfdir}/depmod.d/
install %{name}.conf %{buildroot}%{_sysconfdir}/depmod.d/

%define _unpackaged_files_terminate_build 0

%postun doc
if [ -f %{_mandir}/man7/ixgbe.7.gz ]; then
	exit 0
fi

%clean
rm -rf %{buildroot}

%files
%{_sysconfdir}/depmod.d/%{name}.conf

%files doc
%defattr(-, root, root)
%{_mandir}/man7/ixgbe.7.gz
%doc source/COPYING source/README

%changelog
* Wed May 16 2018 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> %version-%release
- This driver updated the kernel version infor for SLES12sP3

* Mon Nov 06 2017 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.3.3-1
- This driver updated branding strings from HP to HPE for legacy adapters 
- This driver fixes the issue of Unable to automatically get link after swapping SFP+ modules of different speeds 
- This driver fixes the issue of IPV6 magic packet can't wake up
- This driver fixes the issue of unable to set MTU value more than 1500 in SUSE12SP3 with Intel NICs
- This driver fixes linux Kernel panic occurs when assigning an IP address on HVL system with non existing PHY

* Fri Jul 28 2017 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.2.1-4.rhel7u4
- Added support for HPE Ethernet 10Gb 2-port 562FLR-T Adapter
- Added support for HPE Ethernet 10Gb 2-port 562T Adapter
- Added SLES12SP3 support
- Added RHEL 7.4 support
- Fix the issue of sriov_totalvfs reporting incorrect number of supported VFs
- Fix the issue of RHEL6.9 64 bit is not able to create Virtual Functions with the sysfs command

* Tue Mar 21 2017 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.0.7-2[rhel6u9], 5.0.7-1[For other OSs]
- Added SLES12SP2 support
- Added RHEL 7.3 support
- Fix the issue of Vlan interface in RHEL 6.8 VM on RHEL6.8 host fails to get IP
- Fix the issue of PHY stack trace and OS crash creating / allocating VFs.
- Fix the issue of Transmit queue stuck [DCB enabled]
- Fix the issue of NULL pointer dereference when enabling SRIOV
- Fix the issue of cannot set MACVLAN if MAC is set by PF, when VF is trusted

* Tue Jun 21 2016 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 4.4.6-1
- Added RHEL 6.8 support
- Fix the issue of unable to dynamically detect SFP module
- Added support for Marvell PHY devices
- Added new netdev operation to trust the Virtual Function
- Added support to check and set the RSS hash and indirection table via ethtool -x/-X parameters	
- Added new netdev op to allow user to enable/disable the ability of a specific VF to query its RSS Indirection Table and an RSS Hash Key
- Fix the issue of packets being dropped as spoofed packets in SR-IOV mode
- Fix the issue of macvlan interfaces not being able to get link, ixgbevf parent loses link
- Fix the issue of ixgbe installation getting corrupted the system's ability to boot from SLES11SP4

* Wed Apr 13 2016 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups
.hp.com> 4.3.13-2
 - Fix the issue of First Virtual Function(VF) receiving a copy of Physical Function(PF)'s traffic
 - Added support for Multicast promiscous mode for trusted Virtual Functions

* Tue Nov 10 2015 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 4.1.5-6
 - Added SLES12SP1 support
 - Added RHEL 7.2 support
 - Used new skb_vlan_tag_* functions instead of old vlan_tx_tag_* functions.
 - This driver addresses an issue where the link speed reported by the HPE Active Health System (AHS) is incorrect.

* Tue Jul 07 2015 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 4.0.3-9
 - Added SLES11SP4 support
 - Added RHEL 6.7 support

* Tue Apr 14 2015 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 4.0.3-1
 - Added RHEL 7.1 support
 - Added SLES11SP4 support
 - Fixed the issue of VXLAN offload tx-udp_tnl-segmenation not getting enabled
 - Made changes to use dma_rmb when accessing RX descriptors.

* Wed Dec 17 2014 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 3.23.0.79
 - Added SLES 12 support
 - Added RHEL 6.6 support
 - Fixes the issue of TX Unit hang which occurs when re-plugging of  network cable while passing traffic on VMs(using VFs)
 - Fixes incorrect reporting of sriov values under sysfs
 - Fixes the issue ixgbe driver causing keyboard delay when DAC Cables are used
 
* Wed May 21 2014 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 3.22.0.2-10
 - Added support for Live Error Recovery(LER)
 - Fixes issue of driver getting hang while using netconsole with busy poll

* Wed Nov 27 2013 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 3.19.0.46-4
 - Fixes kernel panic which occur when sending traffic through vlan with latest stable and cvs
 - Add support for dumping SFF data from the SFP modules
 - Fixes TX hangs on kernels with BQL enabled and ITR>100K/sec
 - Fixes TX hangs which used to occur when Interrupt Throttle Rate(ITR) is disabled with IP forwarding enabled.

* Mon Jul 15 2013 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 3.15.1-5 
 - This driver now supports SRIOV virtual functions
 - This driver now supports HP Ethernet 10Gb 2-port 561FLR-T Adapter
 - This driver now supports HP Ethernet 10Gb 2-port 561T Adapter
 - This driver now supports HP Ethernet 10Gb 1-port P560SFP+ Adapter
